/* 
 * File:   initialmultiset.cpp
 * Author: fran
 * 
 * Created on 18 January 2010, 10:41
 */

#include "libxml++-2.6/libxml++/libxml++.h"
#include "Misc.h"
#include "InitialMultiset.h"

using namespace std;
using namespace ECSB;
using namespace xmlpp;

//Default constructor
InitialMultiset::InitialMultiset()
{

}

//Copy constructor
InitialMultiset::InitialMultiset(const InitialMultiset& orig)
{
    this->label = orig.label;
    this->multiset = orig.multiset;
}

//Default destructor
InitialMultiset::~InitialMultiset()
{

}

//Constructo from XML specification
InitialMultiset::InitialMultiset(xmlpp::Node* initialMultisetDeclaration)
{
    xmlpp::Element* ini = dynamic_cast<Element*>(initialMultisetDeclaration);

    this->label = (ini->get_attribute("label"))->get_value();

    xmlpp::Node::NodeList objs =
            initialMultisetDeclaration->get_children("object");
    for(xmlpp::Node::NodeList::iterator obj = objs.begin();
        obj != objs.end();
        ++obj)
    {
        xmlpp::Element* object = dynamic_cast<xmlpp::Element*>(*obj);
        std::string objectName =
                (object->get_attribute("name"))->get_value();
        std::string objectMultiplicity =
                (object->get_attribute("multiplicity"))->get_value();
        unsigned long multiplicity =
                fromStringTo<unsigned long> (objectMultiplicity);

        this->multiset[objectName] = multiplicity;
        //this->multiset.insert(pair<std::string,unsigned long>(objectName,multiplicity));
    }
}

//Displayer
void InitialMultiset::show()
{
    std::cout << "Multiset: " << this->label << std::endl;
    for(std::map<std::string,unsigned long>::iterator obj =
            this->multiset.begin();
        obj != multiset.end();
        ++obj)
    {
      std::cout << obj->first << ":" << obj->second << std::endl;
    }
}

