/* 
 * File:   InitialMultiset.h
 * Author: Francisco J. Romero-Campero
 *
 * Created on 18 January 2010, 10:41
 */

#ifndef _INITIALMULTISET_H
#define	_INITIALMULTISET_H

using namespace std;
using namespace xmlpp;


namespace ECSB
{

class InitialMultiset {

public:

    //Constructors
    InitialMultiset();
    InitialMultiset(const InitialMultiset& orig);
    InitialMultiset(xmlpp::Node* initialMultisetDeclaration);

    //Default destructor
    ~InitialMultiset();

    //Getters
    std::string getLabel() { return label; }
    std::map<std::string,unsigned long> getMultiset() { return multiset; }
    unsigned long getMultiplicity(std::string obj) { return multiset[obj]; }

    //Setters
    void setLabel(std::string l) { label = l; }
    void setMultiset(std::map<std::string,unsigned long> m) { multiset = m; }
    void setMultiplicity(std::string obj,unsigned long m) { multiset[obj] = m; }

    //Displayer
    void show();



private:

    std::string label;
    std::map<std::string,unsigned long> multiset;


};

}

#endif	/* _INITIALMULTISET_H */

