/* 
 * File:   LPPCompartment.cpp
 * Author: Francisco J. Romero-Campero
 * 
 * Created on 17 January 2010, 23:47
 */

#include "LPPCompartment.h"

using namespace ECSB;
using namespace std;
using namespace xmlpp;


//Default constructor
LPPCompartment::LPPCompartment()
{

}

//Copy constructor
LPPCompartment::LPPCompartment(const LPPCompartment& orig)
{
    this->children = orig.children;
    this->father = orig.father;
    this->label = orig.label;
    this->name = orig.name;
    this->numberId = orig.numberId;
}

//Default destructor
LPPCompartment::~LPPCompartment()
{

}

//Constructor from XML specification
LPPCompartment::LPPCompartment(xmlpp::Node* compartmentDeclaration)
{
    //Construct the different components of a compartment
    xmlpp::Element* compartment = dynamic_cast<xmlpp::Element*>(compartmentDeclaration);
    this->name = (compartment->get_attribute("name"))->get_value();
    this->label = (compartment->get_attribute("label"))->get_value();
    xmlpp::Attribute* fatherDeclaration = compartment->get_attribute("father");

    //Father is an optional attribute
    if(fatherDeclaration != NULL)
      this->father = fatherDeclaration->get_value();
}

//Displayer
void LPPCompartment::show()
{
  std::cout << "\tCompartment " << this->name << " : " << std::endl;
  std::cout << "\t\tlabel: " << this->label << std::endl;
  std::cout << "\t\tfather: " << this->father << std::endl;
  std::cout << "\t\tchildren: " << std::endl;

  for(std::vector<std::string>::iterator ch = this->children.begin();
    ch != this->children.end();
    ++ch)
  {
      std::cout << "\t\t\t" << *ch << std::endl;
  }
}
