/* 
 * File:   LPPCompartment.h
 * Author: Francisco J. Romero-Campero
 *
 * Created on 17 January 2010, 23:47
 */

#ifndef _LPPCOMPARTMENT_H
#define	_LPPCOMPARTMENT_H


#include <iostream>
#include <libxml++/libxml++.h>
#include <string>
#include <vector>

using namespace std;
using namespace xmlpp;

namespace ECSB
{

class LPPCompartment {

public:
    //Constructors
    LPPCompartment();
    LPPCompartment(const LPPCompartment& orig);
    LPPCompartment(xmlpp::Node* compartmentDeclaration);

    //Default destructor
    ~LPPCompartment();

    //Getters
    std::string getName() { return name; }
    unsigned long getNumberId() { return numberId; }
    std::string getLabel() { return label; }
    std::string getFather() { return father; }
    std::vector<std::string> getChildren() { return children; }

    //Setters
    void setName(std::string n) { name = n; }
    void setNumberId(unsigned long id) { numberId = id; }
    void setLabel(std::string l) { label = l; }
    void setFather(std::string f) { father = f; }
    void setChildren(std::vector<std::string> ch) { children = ch; }

    //Displayer
    void show();

private:
    std::string name;
    unsigned long numberId;
    std::string label;
    std::string father;
    std::vector<std::string> children;

};

}
#endif	/* _LPPCOMPARTMENT_H */

