/*
 * File:   LPPRuleset.h
 * Author: Francisco J. Romero-Campero
 *
 * Created on 18 January 2010, 11:06
 */

#ifndef _LPPRULESET_H
#define	_LPPRULESET_H

#include <vector>
#include <string>
#include "LPPRule.h"

#include <libxml++-2.6/libxml++/libxml++.h>

using namespace std;
using namespace ECSB;
using namespace xmlpp;

namespace ECSB {

class LPPRuleSet {

public:

    //Constructors
    LPPRuleSet();
    LPPRuleSet(const LPPRuleSet& orig);
    LPPRuleSet(xmlpp::Node* ruleSetDeclaration);

    //Default destructor
    ~LPPRuleSet();

    //Getters
    std::string getLabel() { return label; }
    unsigned int getNumberRules() { return numberRules; }
    std::vector<LPPRule> getRules() { return setOfRules;}
    std::list<std::string> getObjects();

    //Setters
    void setLabel(std::string l) { label = l ; }
    void setNumberRules(unsigned int n) { numberRules = n; }
    void setRules(std::vector<LPPRule> s) { setOfRules = s;}
    void addRule(LPPRule rule)
    {
        setOfRules.push_back(rule);
        numberRules++;
    }

    //Displayer
    void show();

private:
    std::string label;
    unsigned int numberRules;
    std::vector<LPPRule> setOfRules;
};

}

#endif	/* _LPPRULESET_H */

