/* 
 * File:   ModuleLibrary.h
 * Author: Francisco J. Romero-Campero
 *
 * Created on 18 January 2010, 15:14
 */

#ifndef _MODULELIBRARY_H
#define	_MODULELIBRARY_H

#include <map>
#include <string>

#include "ModuleDefinition.h"

using namespace std;
using namespace xmlpp;

namespace ECSB {

class ModuleLibrary {

public:
    //Constructs
    ModuleLibrary();
    ModuleLibrary(const ModuleLibrary& orig);
    ModuleLibrary(std::string libraryFile);

    //Default destructor
    ~ModuleLibrary();

    //Getters
    std::string getName() { return name; }
    std::map<std::string,ModuleDefinition> getModules() { return modules; }

    //Setters
    void setName(std::string n) { name = n; }
    void setModules(std::map<std::string,ModuleDefinition> m) { modules = m; }
    void addModule(ModuleDefinition m)
    {
        (this->modules)[m.getName()] = m;
    }

    //Displayer
    void show();

protected:
    //Auxiliary function to create a module library from an XML specification
    void createFromXML(std::string fileName);

private:
    std::string name;
    std::map<std::string,ModuleDefinition> modules;


};

}

#endif	/* _MODULELIBRARY_H */

