/*
 * File:   parameter.cpp
 * Author: Francisco J. Romero-Campero
 *
 * Created on 15 January 2010, 15:48
 */

#include "Parameter.h"

using namespace std;
using namespace ECSB;
using namespace xmlpp;

//Default constructor
parameter::parameter()
{

}

//Copy constructor
parameter::parameter(const parameter& orig)
{
    this->name = orig.name;
    this->lowerBound = orig.lowerBound;
    this->upperBound = orig.upperBound;
    this->step = orig.step;
}

//Default destructor
parameter::~parameter()
{

}

//Constructor from XML specification
parameter::parameter(xmlpp::Node* parameterDeclaration)
{
  //Instantiate the different members of a parameter
  xmlpp::Element* param = dynamic_cast<xmlpp::Element*>(parameterDeclaration);

  //Name
  xmlpp::Attribute* nameAttribute = param->get_attribute("name");
  if(nameAttribute != NULL)
  {
      this->name = nameAttribute->get_value();
  }
  else
  {
      cerr<< "Error: parameter without name" <<std::endl;
      exit(EXIT_FAILURE);
  }

  //Lower Bound
  xmlpp::Attribute* lowerBoundAttribute = param->get_attribute("lowerBound");
  if(lowerBoundAttribute != NULL)
  {
      this->lowerBound = fromStringTo<int>(lowerBoundAttribute->get_value());
  }
  else
  {
      cerr<< "Error: parameter without lower bound" <<std::endl;
      exit(EXIT_FAILURE);
  }

  //Upper Bound
  xmlpp::Attribute* upperBoundAttribute = param->get_attribute("upperBound");
  if(upperBoundAttribute != NULL)
  {
      this->upperBound = fromStringTo<int>(upperBoundAttribute->get_value());
  }
  else
  {
      cerr<< "Error: parameter without upper bound" <<std::endl;
      exit(EXIT_FAILURE);
  }

  //Step
  xmlpp::Attribute* stepAttribute = param->get_attribute("step");
  if(stepAttribute != NULL)
  {
      this->step = fromStringTo<int>(stepAttribute->get_value());
  }
  else
  {
      cerr<< "Error: parameter without step" <<std::endl;
      exit(EXIT_FAILURE);
  }

}

