/* 
 * File:   parameter.h
 * Author: Francisco J. Romero-Campero
 *
 * Created on 15 January 2010, 15:48
 */

#ifndef _PARAMETER_H
#define	_PARAMETER_H

#include <libxml++/libxml++.h>
#include <string>

#include "Misc.h"

using namespace std;
using namespace xmlpp;

namespace ECSB
{

class parameter {
public:
    //Constructors
    parameter();
    parameter(const parameter& orig);
    parameter(xmlpp::Node* parameterDeclaration);
    
    //Default destructor
    ~parameter();

    //Getters
    std::string getName() { return name; }
    int getLowerBound() { return lowerBound; }
    int getUpperBound() { return upperBound; }
    int getStep() { return step; }

    //Setters
    void setName(std::string n) { name = n; }
    void setLowerBound(int lb) { lowerBound = lb; }
    void setUpperBound(int ub) { upperBound = ub; }
    void setStep(int s) { step = s; }


private:
    std::string name;
    int lowerBound;
    int upperBound;
    int step;
};

}

#endif	/* _PARAMETER_H */

