// parameter set class definitions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef PARAMETERSET_H
#define PARAMETERSET_H

#include <iostream>

namespace ECSB {

#define PARAMETER_STR_MAX 512

// ParameterSet class
class ParameterSet {
	protected:
		// name of class
		std::string classname;
		
		// filename of parameter file
		std::string filename;
	
	public:
		// constructor
		ParameterSet(const char *name);
		
		// destructor
		~ParameterSet() {};

		// set a parameter value
		virtual bool setParameter(char *name, char *value) = 0;
		
		// read parameters from an xml file
		void read(char *filename);
		
		// read parameters from an xml file and command line
		void read(int argc, char **argv);
		
		// return name of parameter set
		std::string getClassName(void);		

		// return filename of parameter set
		std::string getFilename(void);		
};

}

#endif
