// random number generation functions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef RANDOMNUMBER_H
#define RANDOMNUMBER_H

// distribution identifiers
#define GAUSSIAN_DISTRIBUTION	0

namespace ECSB {

// initialise generator
unsigned long initialiseRandomNumberGenerator(unsigned long);

// release memory for random number generator
void freeRandomNumberGenerator(void);

// generate a uniform random number on the interval [0,1)
double randomNumber(void);

// generate a uniform random number on the interval (0,1)
double randomNumberPos(void);

// generate a uniform random non-negative integer
unsigned long randomNonnegativeInteger(unsigned long);

// generate a gaussian random number
double gaussianRandomNumber(double, double);

// generate a non-negative gaussian random number
double gaussianRandomNumberNN(double, double);

// divide integer by two and round up or down randomly
unsigned long randomHalf(unsigned long);

}

#endif
