// signal handler functions
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef SIGNALHANDLER_H
#define SIGNALHANDLER_H

#ifdef WIN32
#include <signal.h>
#else
#include <sys/signal.h>
#endif
#include <sigc++/slot.h>
#ifndef SIGUSR1
#define SIGUSR1 16
#endif

namespace ECSB {

#define MAX_SIGNAL 32

typedef sigc::slot0<void> Slot;

// signal handler class
class SignalHandler {		
		// signal handlers
		static Slot handler[MAX_SIGNAL];
  
		// ignore signal handlers
		static bool handler_ignore[MAX_SIGNAL];
  
		// execute handler for signal
		static void caught(int sig);

	public:
		// set handler for signal
		static void set_handler(unsigned int sig, Slot slot);

		// unset handler for signal
		static void unset_handler(unsigned int sig);

		// ignore previously set signal
		static void ignore_handler(unsigned int sig);

		// unignore previously set signal
		static void unignore_handler(unsigned int sig);
};

}

#endif
