// create parameter classes from parameter set xml
// example usage
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

// include the parameter class
#include "TestParameters.h"

#include <iostream>

using namespace std;

// use the parameters
void useParameters(TestParameters &parameters)
{
	// just dump the parameters to stdout
	cout << "integer_parameter1=" << parameters.integer_parameter1 << "\n";
	cout << "integer_parameter2=" << parameters.integer_parameter2 << "\n";
	cout << "float_parameter=" << parameters.float_parameter << "\n";
	cout << "double_parameter=" << parameters.double_parameter << "\n";
	cout << "char_parameter=" << parameters.char_parameter << "\n";
	cout << "bool_parameter=" << parameters.bool_parameter << "\n";
	cout << "string_parameter1=" << parameters.string_parameter1 << "\n";
	cout << "string_parameter2=" << parameters.string_parameter2 << "\n";
	cout << "cppstring_parameter=" << parameters.cppstring_parameter << "\n";
	cout << "filename_parameter=" << parameters.filename_parameter << "\n";
	cout << "long_parameter=" << parameters.long_parameter << "\n";
	cout << "ulong_parameter=" << parameters.ulong_parameter << "\n";
}

int main(int argc, char **argv)
{
	// parse command line
	if(argc != 2) {
		cerr << "usage: test-parameters XML_PARAMETER_FILE\n";
		return 1;
	}

	// initialise the parameter class
	TestParameters parameters;

	// read the parameters from xml parameter file
	parameters.read(argv[1]);

	// use the parameters
	useParameters(parameters);

	// write parameters to a file
	parameters.write("saved-parameters.xml");

	return 0;
}
